# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free
%define base_version 3.1
%define main_version 3.1.3
%define hname hibernate

Summary:        Relational persistence and query service
Name:           %{hname}3
Version:        %{main_version}
Release:        2jpp
Epoch:          0
License:        LGPL
URL:            http://www.hibernate.org/
Group:          Database
Vendor:         JPackage Project
Distribution:   JPackage
Source0:        %{hname}-%{version}.tar.gz

BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:  java-devel >= 0:1.4
BuildRequires:  ant
BuildRequires:  ant-antlr
BuildRequires:  antlr
BuildRequires:  ant-junit
BuildRequires:  junit
BuildRequires:  ant-swing
BuildRequires:  asm
BuildRequires:  c3p0
BuildRequires:  cglib >= 0:2.0
BuildRequires:  concurrent
BuildRequires:  jakarta-commons-collections >= 0:2.1
BuildRequires:  jakarta-commons-logging
BuildRequires:  jgroups
BuildRequires:  hsqldb >= 0:1.72
BuildRequires:  dom4j 
BuildRequires:  jaxen >= 0:1.1
BuildRequires:  j2ee-connector
BuildRequires:  jaas
BuildRequires:  jacc
BuildRequires:  jdbc-stdext
BuildRequires:  jta
BuildRequires:  log4j
BuildRequires:  ehcache >= 0:1.1
BuildRequires:  oscache
BuildRequires:  proxool
BuildRequires:  swarmcache
BuildRequires:  jboss4-cache >= 0:4.0.2
BuildRequires:  jboss4-common >= 0:4.0.2
BuildRequires:  jboss4-jmx >= 0:4.0.2
BuildRequires:  jboss4-system >= 0:4.0.2
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-apis
Requires:  java >= 0:1.4
Requires:  hibernate_jdbc_cache
Requires:  hibernate_in_process_cache	
Requires:  cglib >= 0:2.0
Requires:  jakarta-commons-collections >= 0:2.1
Requires:  jakarta-commons-logging
Requires:  dom4j
Requires:  jdbc-stdext
Requires:  jta
Requires:  xml-commons-apis
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Hibernate is a powerful, ultra-high performance 
object/relational persistence and query service 
for Java. Hibernate lets you develop persistent 
objects following common Java idiom - including 
association, inheritance, polymorphism, composition 
and the Java collections framework. Extremely 
fine-grained, richly typed object models are 
possible. The Hibernate Query Language, designed 
as a "minimal" object-oriented extension to SQL, 
provides an elegant bridge between the object and 
relational worlds. Hibernate is now the most 
popular ORM solution for Java.


%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
Javadoc for %{name}.

%prep
%setup -q -n %{hname}-%{base_version}
# remove all binary libs
#find . -name "*.jar" -exec mv {} {}.no \;
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done


%build
export OPT_JAR_LIST="ant/ant-swing ant/ant-antlr antlr ant/ant-junit junit ant-launcher"
build-jar-repository -s -p lib \
ant \
ant/ant-antlr \
ant/ant-junit \
ant/ant-swing \
ant-launcher \
antlr \
asm/asm \
asm/asm-attrs \
c3p0 \
cglib \
commons-collections \
commons-logging \
concurrent \
dom4j \
ehcache \
hsqldb \
j2ee-connector \
jaas \
jacc \
jaxen \
jboss4/jboss-cache \
jboss4/jboss-common \
jboss4/jboss-jmx \
jboss4/jboss-system \
jdbc-stdext \
jgroups \
jta \
junit \
log4j \
oscache \
proxool \
swarmcache \
xerces-j2 \
xml-commons-apis \


CLASSPATH=$CLASSPATH:build/classes:build/testclasses:etc
ant jar extras junitreport javadoc 

# TEST org.hibernate.test.hql.HQLTest FAILED
# (known issue, fails with sun and bea)
# TEST org.hibernate.test.id.MultipleHiLoPerTableGeneratorTest FAILED
# (testDistinctId: fails with bea)
# TEST org.hibernate.test.legacy.FumTest FAILED
# (testDeleteOwner: fails with bea)
# TEST org.hibernate.test.legacy.ParentChildTest FAILED
# (testLocking: fails with bea)
# TEST org.hibernate.test.legacy.SQLLoaderTest FAILED
# (testReturnPropertyComponentRename: known with hsqldb?, fails with sun and bea)
# TEST org.hibernate.test.proxy.ProxyTest FAILED
# (testProxySerialization: known with hsqldb?, fails with sun and bea)
# TEST org.hibernate.test.readonly.ReadOnlyTest FAILED
# (testReadOnlyOnProxiesFailureExpected: known with hsqldb?, fails with sun and bea)
# TEST org.hibernate.test.stats.StatsTest FAILED
# (testQueryStatGathering: known with hsqldb?, fails with sun and bea)

%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}

cp -p %{name}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc
cp -p etc/* $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr doc/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf doc/api

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p lgpl.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr doc/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/lgpl.txt
%{_javadir}/*.jar
%{_datadir}/%{name}-%{version}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}

%changelog
* Tue May 16 2006 Ralph Apel <r.apel@r-apel.de> - 0:3.1.3-2jpp
- Rebuild in JPP-1.6 environment

* Tue Mar 28 2006 Ralph Apel <r.apel@r-apel.de> - 0:3.1.3-1jpp
- Update to 3.1.3

* Wed Feb 22 2006 Ralph Apel <r.apel@r-apel.de> - 0:3.1.1-1jpp
- Update to 3.1.1

* Thu Dec 22 2005 Fernando Nasser <fnasser@redhat.com> - 0:3.0.5-2jpp
- First JPP 1.7 build

* Fri Aug 05 2005 Ralph Apel <r.apel at r-apel.de> - 0:3.0.5-1jpp
- change name to hibernate3 and upgrade to 3.0.5

* Mon Sep 13 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.1.6-1jpp
- Drop saxpath requirements
- Require jaxen >= 0:1.1
- Upgrade to 2.1.6
- Activate clover task (clover10)

* Wed Aug 25 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.1.4-4jpp
- Build with ant-1.6.2
- Drop ant-optional BuildReq
- Relax some versioned dependencies

* Thu Jul 02 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.1.4-3jpp
- Relax some versioned build dependencies 
- Reduce runtime dependencies
- Require hibernate_in_process_cache and hibernate_jdbc_cache at runtime

* Thu Jun 17 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.1.4-2jpp
- Try avoid symlinking into lib

* Tue Jun 08 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.1.4-1jpp
- First JPackage release
